//
/*
	Header file of
	The brains of othello playing program.
	TheMaster Version 1.1

	Version 1.1 improvements over 1.0:
		- The brain isolated from interface into a separate replaceable file.

	CopyRight(c) Gaurang Khetan, Pune.
	Date: 17/4/1999
*/
//

class alloc_class
	{
 private:
	pos* start_board;
	char* start_move_struc;
	int used_board;
	int used_move_struc;

 public:
	boolean set();
	void reset();

	pos* new_board();
	void delete_board(pos*);

	char* new_move_struc();
	void delete_move_struc(char*);
	};

class TheMaster2
	{
 private:
	alloc_class alloc;

	pos order[60];
	id me_id, you_id;
	score start_alpha, start_beta;

	pos* board;
	movetype move;
	score cur_score;
	int moves_over;

	int eval_level;
	int min_depth;

	//private functions:

	//1> direct functions
	boolean is_legal ( id, movetype);
	void play_move(id, movetype);   //POLYMORPHISM!
	int no_of_legal_moves(id);   //POLYMORPHISM!
	movetype next_move(id, int&);//POLYMORPHISM!

	//2> move structure based moves --- the char* signifies movestruc*
	void set_up_legal_moves(id, char*);
	boolean is_legal ( char* , movetype);
	void play_move(id, char*, int); //POLYMORPHISM!
	int no_of_legal_moves(char*);// POLYMORPHISM!
	movetype next_move(char*, int&); //POLYMORPHISM!

	score evaluate (id, score, score, int);
	score eg_evaluate (id, score, score);

	score stat_eval(id who);
	int strat_1(id);
	int strat_2(id);
	int strat_3(id);
	int strat_4(id);

	int no_of_pieces(id);
	int moves_finished();

	id opp(id t) { return me_id + you_id - t; }

 public:
	TheMaster2();
	~TheMaster2();

	void set_id(id meid, id youid);
	void set_depth(int md);
	void set_eval_level(int);

	score get_cur_score();
	movetype make_move(pos*);

	};

